<template lang="pug">
div
  q-dialog(v-model="playvideo")
    q-card(style="width: 700px; max-width: 90vw")
      q-video(
        v-if="currentvideo.youtube",
        :src="'https://www.youtube.com/embed/' + currentvideo.youtube",
        :ratio="16 / 9"
      )
      q-video(
        v-if="!currentvideo.youtube",
        :src="getNonTubeLink(currentvideo)",
        :ratio="16 / 9"
      ) 
      q-btn.full-width(
        color="grey-5",
        dense,
        flat,
        type="a",
        :href="getNonTubeLink(currentvideo)",
        target="_blank"
      ) {{ $t('no_youtube') }}
  q-page(padding)
    .text-h3.text-center.q-mb-xl.q-mt-lg.text-secondary {{ $t('innovation_submissions') }}
    .text-h4.text-center.q-mb-xl.q-mt-lg.text-secondary We are proud to present the young people below who have been selected for the 2021 IFRC Youth Innovation Academy.

    q-infinite-scroll(scroll-target="body", ref="scroller", @load="onLoad")
      template(v-slot:loading)
        .row.justify-center.q-my-md
          q-spinner-dots(color="primary", size="40px")

      .text-center(v-if="!allsubmissions.length && !loading") {{ $t('no_submissions') }}

      .row.q-col-gutter-md.items-stretch
        .col-12.col-sm-6.col-md-4.col-lg-3(
          v-for="submission in allsubmissions",
          :key="submission.id"
        )
          q-card.fit(flat, bordered)
            q-img.cursor-pointer(
              :ratio="16 / 9",
              :src="getThumbnail(submission)",
              @click="currentvideo = getHdVideo(submission); playvideo = true"
            )
            q-card-section.q-pa-sm
              q-chip
                q-avatar(circle, v-if="submission.submitted_by.photo_url")
                  q-img(:src="submission.submitted_by.photo_url")
                q-avatar.bg-grey-5(
                  circle,
                  v-if="!submission.submitted_by.photo_url"
                ) 
                  q-icon(:name="matPerson")
                span {{ submission.submitted_by.user_name }}
                q-tooltip(max-width="400px", v-if="submission.team")
                  q-chip(v-for="team in submission.team", :key="team.name")
                    q-avatar.bg-grey-5(circle)
                      q-icon(:name="matPerson")
                    span {{ team.name }}
              span(v-if="submission.team") +{{ submission.team.length }}
              div
              q-chip.q-pl-none.q-pr-none(
                rounded,
                color="transparent",
                text-color="white"
              )
                .flag {{ getRegion(submission.region).flag }}
                q-tooltip {{ getRegion(submission.region).name }}
              q-chip.q-pl-md.q-pr-sm.on-left(
                rounded,
                color="transparent",
                v-for="tag of submission.tags",
                :key="tag",
                :icon="getTagIcon(tag)",
                text-color="primary"
              )
                q-tooltip {{ $t('tags.' + tag) }}
</template>

<script>
import { mapState, mapActions, mapGetters } from "vuex";
import Language from "@/mixins/Language";
import find from "lodash/find";
let regions = require("../ifrclist.json");

export default {
  props: ["logo", "filter"],
  mixins: [Language],
  async mounted() {
    this.logo.filter = true;
    await this.initConfig();
  },
  beforeDestroy() {
    this.logo.filter = false;
  },
  data: () => {
    return {
      loading: true,
      currentvideo: {},
      playvideo: false,
    };
  },
  watch: {
    filter: {
      immediate: false,
      deep: true,
      handler() {
        this.resetSubmissions();
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  methods: {
    getRegion(region) {
      return find(regions, { code: region });
    },
    getNonTubeLink(media) {
      // console.log(media);
      if (!media) return "";
      if (!media.src) return "";
      return `${this.config.cloudfronturl}${media.src
        .replace("s3://", "")
        .replace(this.config.bucketname, "")
        .replace("hd_video", "hd_video_transcoded")}`;
    },
    getS3Link(src) {
      // console.log(src);
      if (!src) return "";
      let url = `${this.config.cloudfronturl}${src
        .replace("s3://", "")
        .replace(this.config.bucketname, "")}`;
      return url;
    },
    getHdVideo(submission) {
      return find(submission.media, { type: "hd_video" });
    },
    getThumbnail(submission) {
      // console.log(submission.raw);
      let raw = find(submission.media, { type: "raw" });
      return `${this.getS3Link(raw.src).replace(".mp4", "")}.0000002.jpg`;
    },
    async onLoad(index, done) {
      let lastlen = this.allsubmissions.length;
      this.loading = true;
      await this.getAllSubmissions(this.filter);

      let currentlen = this.allsubmissions.length;
      this.loading = false;

      done(lastlen == currentlen);
    },
    ...mapActions(["getAllSubmissions", "initConfig", "resetSubmissions"]),
  },
  computed: {
    ...mapState(["allsubmissions", "config"]),
    ...mapGetters(["getTagIcon"]),
  },
};
</script>

<style src="@platyplus/humanitarian-icons/dist/icons.css">
/* global styles */
</style>
